// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "PokerWinning.hpp"

namespace Dawn {
  class PokerPlayer;
  class PokerGame;
  struct PokerPot;

  struct PokerPotWinning {
    public:
      std::map<std::shared_ptr<PokerPlayer>, struct PokerWinning> winnings;
      std::vector<std::shared_ptr<PokerPlayer>> winners;
      std::vector<std::shared_ptr<PokerPlayer>> participants;
      struct PokerPot *pot;
      int32_t chipsEach;
      int32_t chipsOverflow;

      void award();
  };
  
  struct PokerPot {
    public:
      int32_t chips;
      int32_t call;
      std::vector<std::shared_ptr<PokerPlayer>> players;

      /**
       * Get the winners of the pot.
       * 
       * @return The winning state of the pot.
       */
      struct PokerPotWinning getWinners();
  };
}