// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "event/CustomEvent.hpp"

namespace Dawn {
  class TimeoutEvent : public CustomEvent<float_t, float_t, float_t> {
    protected:
      enum CustomEventResult shouldEmit(const float_t &listener) override;
      float_t transformData(const float_t &timeout) override;
    
    public:
      TimeoutEvent();

      /**
       * Ticks this timeout event by a time delta amount. Will also emit all
       * events that are ready to be emitted.
       * 
       * @param delta Delta time.
       */
      void tick(const float_t delta);
  };
}