// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "Easing.hpp"

using namespace Dawn;

float_t Easing::linear(float_t t) {
  return t;
}

float_t Easing::easeInQuad(float_t t) {
  return t * t;
}

float_t Easing::easeOutQuad(float_t t) {
  return t * (2 - t);
}

float_t Easing::easeInOutQuad(float_t t) {
  return t < 0.5 ? 2 * t * t : -1 + (4 - 2 * t) * t;
}

float_t Easing::easeInCubic(float_t t) {
  return t * t * t;
}

float_t Easing::easeOutCubic(float_t t) {
  return (--t) * t * t + 1;
}

float_t Easing::easeInOutCubic(float_t t) {
  return t < 0.5 ? 4 * t * t * t : (t - 1) * (2 * t - 2) * (2 * t - 2) + 1;
}

float_t Easing::easeInQuart(float_t t) {
  return t * t * t * t;
}

float_t Easing::easeOutQuart(float_t t) {
  return 1 - (--t) * t * t * t;
}

float_t Easing::easeInOutQuart(float_t t) {
  return t < 0.5 ? 8 * t * t * t * t : 1 - 8 * (--t) * t * t * t;
}